/// <reference types="knockout" />
import { FrameworkElement, FrameworkElementOptions } from "../../framework/frameworkElement";
export declare class SelectBox<TItem> extends FrameworkElement {
    constructor(options?: SelectOptions<TItem>);
    options: Array<TItem> | KnockoutObservableArray<TItem>;
    optionsCaption: string;
    optionsText: keyof TItem;
    optionsValue: keyof TItem;
    value: any | KnockoutObservable<any>;
    onchange: (value: any) => void;
}
export interface SelectOptions<TItem> extends FrameworkElementOptions {
    options?: Array<TItem> | KnockoutObservableArray<TItem>;
    optionsCaption?: string;
    optionsText?: keyof TItem;
    optionsValue?: keyof TItem;
    value?: any | KnockoutObservable<any>;
    onchange?: (value: any) => void;
}
