/// <reference types="knockout" />
import { FrameworkElement } from "../index";
import { Style } from "../style/style";
export declare class Dialog {
    constructor(options?: DialogOptions);
    private element;
    open(): void;
    close(): void;
    title: string | FrameworkElement;
    content: FrameworkElement;
    actions: Array<DialogAction> | KnockoutObservableArray<DialogAction>;
}
export interface DialogOptions {
    title: string | FrameworkElement;
    titleStyle: Style;
    content: FrameworkElement;
    contentStyle: Style;
    actions: Array<DialogAction> | KnockoutObservableArray<DialogAction>;
    actionsStyle: Style;
}
export interface DialogAction {
    caption: string | FrameworkElement;
    onexecute: () => Promise<boolean> | boolean;
    closeOnFail?: boolean;
}
