import { FrameworkElement, FrameworkElementOptions } from "./frameworkElement";
export declare abstract class ItemsElement<TItem extends FrameworkElement> extends FrameworkElement {
    protected constructor(tagName: string, type: string, options?: ItemsElementOptions<TItem>);
    private renderItems;
    private items;
    getItems: () => TItem[];
    setItems: (items: TItem[]) => void;
    insertItem: (newItem: TItem, referenceItem?: TItem) => void;
    removeItem: (itemToRemove: TItem) => void;
}
export interface ItemsElementOptions<TItem extends FrameworkElement> extends FrameworkElementOptions {
    items?: Array<TItem>;
}
